<?php

/*

////////////////////////
// License Information
////////////////////////

THIS is a copyrighted file.
You are free to use it on your Website IF you are a customer of SitePad.
You may also add your copyrights.
This license PERMITS SitePad Customers to remove ALL REFERENCES to SitePad (IF desired)

*/

include('functions.php');
define('SITEMUSH', 1);

// Update the scripts.php if required
$last_updated = @file_get_contents('updated.txt');

// We need to save the new scripts.php
if(empty($last_updated) || $last_updated < (time() - (60*30)) || isset($_GET['themes'])){
	$fp = fopen('themes.json', "w");
	fwrite($fp, file_get_contents('http://s2.softaculous.com/a/sitepad/themes.json'));
	fclose ($fp);

	$fp = fopen('categories.json', "w");
	fwrite($fp, file_get_contents('http://s2.softaculous.com/a/sitepad/categories.json'));
	fclose ($fp);
	// Update the TIME of update
	file_put_contents('updated.txt', time());
}

$themes = get_themes();
$num_themes = num_themes();
$categories = get_categories();
$paged = (int) optREQ('paged');
if(empty($paged)) $paged = 1;
$perpage = 15;
$url['url'] = 'http'.(empty($_SERVER['HTTPS']) ? '' : 's').'://'.(empty($_SERVER['HTTP_HOST']) ? $_SERVER['SERVER_NAME'] : $_SERVER['HTTP_HOST']).rtrim(dirname($_SERVER['PHP_SELF']), '/');
$url['images'] = 'https://s5.softaculous.com/a/sitepad/';
$url['sitepad_demos'] = 'https://demos.sitepad.com';


// Add themes count to category
foreach($themes as $tk => $tv){
	if(array_key_exists($tv['category'], $categories)){
		$categories[$tv['category']]['count'] = (empty($categories[$tv['category']]['count']) ? 1 : $categories[$tv['category']]['count']+1);
	}
}

function cmp_category($a, $b) {
	if($a['count'] == $b['count']){
		return 0;
	}
	return ($a['count'] > $b['count']) ? -1 : 1;
}

// Sort the categories by number of themes in respective category
uasort($categories, 'cmp_category');

function sm_render_themes($themes){
global $categories, $catwise, $allcatwise, $spobs, $url, $lang, $env, $paged, $perpage;
	
	$i = $paged - 1;
	$pagedarray = array_chunk($themes, $perpage, true);
	$showthemes = $pagedarray[$i];

	$_str = '<div id="search_category"></div>';
	$_str .= paginate_function('top', $themes);
	$_str .= '<div class="row" id="cat_paginate">';
	foreach($showthemes as $k => $v){
		$urlname = str_replace(' ', '_', $v['name']);
		$demo_link = $url['sitepad_demos'].'/'.$urlname."/";
		
		$_str .= '
		<div class="panel panel-default col-xs-12 col-sm-4 col-md-4">
			<div class="panel-heading h4 col-sm-12 col-md-12"><a href="'.$url['url'].'/?cat='.$v['category'].'&tname='.$urlname.'" style="cursor:pointer;">'.$v['name'].'</a><a href="'.$demo_link.'" target="_blank" class="pull-right demourl">Demo</a></div>
			<div class="panel-body">
				<a href="'.$url['url'].'/?cat='.$v['category'].'&tname='.$urlname.'"><img class="img-responsive" src="'.$url['images'].'files/themes/'.$v['slug'].'/screenshot.jpg" alt="" /></a>
			</div>
		</div>
		'; 
	}
	$_str .= '</div>';
	$_str .= paginate_function('bottom', $themes);
	
	return $_str;
	
}

function paginate_function($location = 'top', $showthemes){
	
	global $perpage, $paged, $spobs, $url;
	
	$cat = optREQ('cat');
	$pagedurl = '';
	$baseurl = $url['url'].'/';
	if(!empty($cat)){
		$baseurl .= '?cat='.$cat;
	}
	
	$_str = '';
	$total_pages = ceil(count($showthemes)/$perpage);

	$current_page = 1;
	// Is it a valid page
	if(!empty($paged)){
		$current_page = $paged;
	}
	
	if($paged > $total_pages){
		$current_page = $paged = 1;
	}
	
	if($total_pages > 1){
		
		$_str .= '<div class="row" id="pagination_'.$location.'">
			<center>
			<ul class="pagination">';
		
		$pagedurl .= $baseurl.(!empty($cat) ? '&' : '?' ).'paged=';
		$previous = $current_page - 1;
		$next = $current_page + 1;
		
		if($current_page > 1){
			$_str .= '<a href="'.$baseurl.'" data-page="1" title="First" class="paginationhref" id="'.(!empty($cat) ? $cat : "" ).'"><li>&laquo;</li></a><a href="'.($previous > 1 ? $pagedurl.$previous : $baseurl ).'" data-page="'.$previous.'" title="Previous" class="paginationhref" id="'.(!empty($cat) ? $cat : "" ).'"><li>&lt;</li></a>';
		}
		
		$start = 1;
		if($current_page > 1){
			$start = $current_page - 1;
		}
		
		$end = $current_page + 1;
		if($end >= $total_pages){
			$end = $total_pages;
		}
		
		for($start; $start <= $end; $start++){
			$_str .= '<a href="'.($start > 1 ? $pagedurl.$start : $baseurl).'" data-page="'.$start.'" title="'.$start.'" class="paginationhref" id="'.(!empty($cat) ? $cat : "" ).'"><li '.($start == $current_page ? ' class="active"' : '').'>'.$start.'</li></a>';
			
		}
		
		if($current_page < $total_pages){
			$_str .= '<a href="'.$pagedurl.$next.'" data-page="'.$next.'" title="Next" class="paginationhref" id="'.(!empty($cat) ? $cat : "" ).'"><li>&gt;</li></a><a href="'.$pagedurl.$total_pages.'" data-page="'.$total_pages.'" title="Last" class="paginationhref" id="'.(!empty($cat) ? $cat : "" ).'"><li>&raquo;</li></a>';
		}
		
		$_str .= '</ul><br /><br />
			</center>
		</div>';
	}
	
	return $_str;
}

function sitepad_allthemes(){
	global $themes;
	return sm_render_themes($themes);
}

function sitepad_showtheme($cat, $name){
	
	global $url, $themes;
	
	
	if(!empty($name)){
		foreach($themes as $slug => $cur) {
			if(strtolower($name) == str_replace(' ', '_', strtolower($cur['name']))){

				$theme = $cur;
			}
		}
	}
	
	if(empty($theme)){
		S::direct($url['url'].'/themes', 1);
	}
	
	$_str = '<div class="row">
		<div class="panel panel-default col-xs-12 col-sm-10 col-md-10 col-sm-offset-1 col-md-offset-1" >
			<div class="panel-heading h4">'.$theme['name'].'<a href="'.$url['sitepad_demos'].'/'.$name.'" target="_blank" class="pull-right demourl">Demo</a></div>
			<div class="panel-body"><img class="img-responsive" src='.$url['images'].'files/themes/'.$theme['slug'].'/screenshot.jpg></div>
		</div>
	</div>';
	
	return $_str;
}

function sitepad_catgegory($cat){

	global $themes, $url;
	
	if(!empty($cat) && $cat != 'all'){
		$cat = strtolower($cat);
		foreach($themes as $slug => $theme) {
			if($cat != strtolower($theme['category'])){
				unset($themes[$slug]);
			}
		}
	}
	
	if(empty($themes)){
		S::direct($url['url'].'/themes', 1);
	}
	
	return sm_render_themes($themes);
}

function sm_searchncats(){

global $categories, $catwise, $allcatwise, $spobs, $url, $lang, $env;

	$_str = '
	<script>
	$(document).ready(function() {
		$("#dropdownfunc").click(function(){
			$("#drpdwnbtn").toggleClass("show-drpdwn");
			$("#drpdwnbtn").toggle();
			$("#showmorebtn").toggleClass("glyphicon-arrow-down glyphicon-arrow-up");
		});
	});

	// jQuery function for searching theme suggestion....
	function suggest(str) {
		if (str.length==0) {
			document.getElementById("suggest_search").innerHTML="";
			document.getElementById("suggest_search").style.border="0px";
			return;
		}
		if (window.XMLHttpRequest) {
			// code for IE7+, Firefox, Chrome, Opera, Safari
			xmlhttp=new XMLHttpRequest();
		} else {  // code for IE6, IE5
			xmlhttp=new ActiveXObject("Microsoft.XMLHTTP");
		}
			xmlhttp.onreadystatechange=function() {

		if (this.readyState==4 && this.status==200) {
			var k = this.responseText;
			k = jQuery.parseJSON(k);
			var txt ="";			// from here add value for search suggestion
			txt = \'<ul id="list-suggestion" style="padding: 0px">\'
			$.each(k, function( i, val ){
				if(val.no_results){
					txt += "<li class=\"inliner\">"+val.no_results+"</li>";
				}else{
					txt += "<a href=\"'.$url['url'].'/?cat="+val.category+"&tname="+val.name.replace(\' \', \'_\')+"'.'\"><li class=\"inliner\">"+val.name+"</li></a>";
				}
			});
			txt += \'</ul>\'
			document.getElementById("suggest_search").innerHTML=txt;
			document.getElementById("suggest_search").style.display="block";
		}
		}
		xmlhttp.open("GET","'.$url['url'].'/search.php?t="+str,true);
		xmlhttp.send();
	}
	</script>
	<div class="section">
	<div class="container">
		<h3 class="orange text-center">Themes</h3><hr class="style-one" />
		<div class="row">		
			<fieldset class="sai_inputs" style="padding:0 0px 0 25px">
				<center>
					<div class="row col-xs-12 col-sm-12 col-md-12" style="padding-right: 10px !important">
						<div class="input-group add-on col-sm-12 col-md-12" >
							<input class="form-control" placeholder="Search Themes" name="search" id="themesearch" type="text" onkeyup="suggest(this.value)" autocomplete="off">						
							<span class="input-group-btn">
								<button class="btn btn-default" type="submit" id="search_button"><i class="glyphicon glyphicon-search"></i></button>
							</span>
						</div>
					</div>
				</center>
				<div id="suggest_search" class="col-sm-12 col-md-12" style="padding: 0px 70px 0px 0px;"></div>
			</fieldset>
		</div>

		<br />
		<div class="row" id="category_menu" style="padding:0 25px 0 25px">
			<center>
			<div class="col-xs-12 col-sm-12 col-md-12 panel-category">
			<a href="'.$url['url'].'/" class="onclick-button"><div class="panel panel-default onclick-button"><h4 class="text-center " name="all" id="category_all_theme" >All</h4></div></a>';
			// To Add categories table
			$cat_count = 0;
			$morediv = '';
			foreach($categories as $slug => $cat){
				if($cat_count < 5){
					$_str .= '<a href="'.$url['url'].'/?cat='.$slug.'" class="onclick-button"><div class="panel panel-block panel-default onclick-button"><h4 class="text-center" name="'.$slug.'" id="category_'.$slug.'" >'.$cat['en'].'</h4></div></a>';
				}else{
					$morediv .= '<a href="'.$url['url'].'/?cat='.$slug.'" class="onclick-button"><div class="panel panel-block panel-more panel-default onclick-button "><h4 class="text-center" name="'.$slug.'" id="category_'.$slug.'" >'.$cat['en'].'</h4></div></a>';
				}
				$cat_count++;
			}
			$_str .= '<div class="panel panel-block panel-default dropbtn-item"><h4 class="text-center" id="dropdownfunc">More <span class="glyphicon glyphicon-arrow-down" id="showmorebtn"></span></h4></div>
			</div>
			<div id="drpdwnbtn" class="drpdwnbtn-content category-more">'.$morediv.'</div>
			</center>
		</div>';
		
	return $_str;	
}

// Handles the listing of the themes
function themes_handle(){

global $categories, $catwise, $allcatwise, $spobs, $url, $lang, $env;

	error_reporting(E_ERROR | E_PARSE);
	header_sm();
	
	$str .= sm_searchncats();
	
	$cat = optREQ('cat');
	$tname = optREQ('tname');
	
	// Show the Main Scripts Page
	if(empty($cat)){
		$str .= sitepad_allthemes();		
	// Its a Theme under Category
	}elseif(!empty($cat) && !empty($tname)){
		$str .= sitepad_showtheme($cat, $tname);
	
	// Its a Category
	}elseif(!empty($cat)){
		$str .= sitepad_catgegory($cat);
	} 
	
	$str .= '</div>
	</div>';
	
	echo $str;
	
	footer_sm();
}

themes_handle();